function FarmInteract(self, unit)
	if unit.tile == self.tile then
		delayunit(unit, unit.laziness() * 3)
		local strength = unit.strength()
		if strength <= 0 then
			strength = 1
		end
		unit.hp = unit.hp - (10 / strength)
		unit.strengthmodifier = unit.strengthmodifier + (math.random(0,5) / 100)
		teamTable[unit.team].wood = teamTable[unit.team].wood - 2 --should be effected by tech later
		teamTable[unit.team].food = teamTable[unit.team].food + 10
	end
end

function FarmUpdate(self)
	if #self.tile.occupants == 1 then
		self.ownership = self.ownership - 1
	elseif self.team > 0 then
		self.ownershipcounter = self.ownershipmax
	end
	if self.ownership < 0 then
		self:destroy()
	end
	if self.team == 0 and #self.tile.occupants > 1 then
		for k,v in ipairs(self.tile.occupants) do
			if v.class == "UNIT" then
				self.team = v.team
				table.insert(teamTable[v.team].buildings)
				break
			end
		end
	end
end