function HouseInteract(self, unit)
	delayunit(unit,unit.laziness() + 6)
	--take any wood off them
	teamTable[unit.team].wood = teamTable[unit.team].wood + unit.wood
	unit.wood = 0
	if teamTable[unit.team].food > 1 then
		unit.hp = unit.maxhp
		teamTable[unit.team].food = teamTable[unit.team].food - 1
	else
		unit.hp = unit.hp + 20
	end
	for k,v in ipairs(self.tile.occupants) do
		if v.class == "UNIT" and v ~= unit then
			if unit.relationships[v.name] and v.relationships[unit.name] then
				-- print(unit.relationships[v.name])
				-- print(v.relationships[unit.name])
				-- print(teamTable[unit.team].food)
				unit.relationships[v.name] = unit.relationships[v.name] + unit.charisma() * math.random(2,5) + 5
				if unit.relationships[v.name] > 100 and v.relationships[unit.name] > 100 and
					teamTable[unit.team].food >= 20 and unit.gender == 1 and v.gender == 2 then
					createUnitReproduction(unit, v, self.tile)
					teamTable[unit.team].food = teamTable[unit.team].food - 20
					unit.maxhp = unit.maxhp * 0.8 --die over time from exhaustion :(
					unit.house = self
					v.house = self
					print(unit.name.." & "..v.name.." have had a child for team "..unit.team)
				end
				if unit.house == self and unit.relationships[v.name] < 0 then
					unit.house = nil
				end
			else
				unit.relationships[v.name] = unit.charisma() * math.random(-1,2)
				v.relationships[unit.name] = v.charisma() * math.random(-1,2)
				unit.relationships[v.name], v.relationships[unit.name] = (unit.relationships[v.name] + v.relationships[unit.name]) / 2, (unit.relationships[v.name] + v.relationships[unit.name]) / 2
			end
			if unit.relationships[v.name] > 30 and v.relationships[unit.name] > 30 then
				unit.house = self
				v.house = self
			end
			unit.charismamodifier = unit.charismamodifier + (math.random(4,12) / 10)
		end
	end
end

function HouseUpdate(self)
	if #self.tile.occupants == 1 and self.team > 0 then
		self.ownership = self.ownership - 1
	elseif self.team > 0 then
		self.ownershipcounter = self.ownershipmax
	end
	if self.ownership < 0 then
		self:loss()
	end
	if self.team == 0 and #self.tile.occupants > 1 then
		for k,v in ipairs(self.tile.occupants) do
			if v.class == "UNIT" then
				self.team = v.team
				table.insert(teamTable[v.team].buildings)
				break
			end
		end
	end
end
