function HUBInteract(self, unit)
	delayunit(unit,unit.laziness() + 2)
	if teamTable[unit.team].food > 1 then
		unit.hp = unit.maxhp
		teamTable[unit.team].food = teamTable[unit.team].food - 1
	else
		unit.hp = unit.hp + 10
	end
	for k,v in ipairs(self.tile.occupants) do
		if v.class == "UNIT" and v ~= unit then
			if unit.relationships[v.name] then
				unit.relationships[v.name] = unit.relationships[v.name] + unit.charisma() * math.random(2,5)
			else
				unit.relationships[v.name] = unit.charisma() * math.random(2,5)
			end
		end
	end
end

function HUBUpdate(self)
	if #self.tile.occupants == 1 and self.team > 0 then
		self.ownership = self.ownership - 0.1
	elseif self.team > 0 then
		self.ownershipcounter = self.ownershipmax
	end
	if self.ownership < 0 then
		self:loss()
	end
	if self.team == 0 and #self.tile.occupants > 1 then
		for k,v in ipairs(self.tile.occupants) do
			if v.class == "UNIT" then
				self.team = v.team
				table.insert(teamTable[v.team].buildings)
				break
			end
		end
	end
end