--house stuff
require("Scripts/Buildings/hub.lua")
require("Scripts/Buildings/house.lua")
require("Scripts/Buildings/farm.lua")

function getBuildingInteractionFunction(building, unit)
	if building.name == "HOUSE" then return HouseInteract(building, unit)
	elseif building.name == "FARM" then return FarmInteract(building, unit)
	elseif building.name == "HUB" then return HUBInteract(building, unit)
	else return false end
end

function getBuildingUpdateFunction(building)
	if building.name == "HOUSE" then return HouseUpdate(building)
	elseif building.name == "FARM" then return FarmUpdate(building)
	elseif building.name == "HUB" then return HUBUpdate(building)
	else return false end
end