function updateUnit(self) --everything a unit needs to do, removed for cleanfiles
	self.lifetime = self.lifetime + 1
	if self.lifetime < self.life / 2 then
		if self.hp < self.maxhp then
			self.hp = self.hp + math.random(2)
			if self.hp > self.maxhp then
				self.hp = self.maxhp
			end
		end
	elseif self.lifetime < self.life then
		self.speed = self.speed * .995
	else
		self:destroy()
	end
	if self.hp <= 0 then
		self:destroy()
	end
		--limit working to prime years later on :D
		--if (round(self.lifetime,1) > self.life / 4) and (round(self.lifetime,1) < self.life * (3/4)) then
	if self.lifetime > self.delay then
		--unit-unit interaction
		for k,v in ipairs(self.tile.neighbours) do
			for k2,unit in ipairs(v.occupants) do
				if unit.class == "UNIT" and unit ~= self then --currently , just random chance stuff, will eventually sim a lot more.
					if self.relationships[unit.name] then
						self.relationships[unit.name] = self.relationships[unit.name] + ((self.charisma() * math.random(-1,3)) / (self.gender + unit.gender)) + 2
						if unit.house and (not self.house or self.relationships[unit.name] > 80) and self.relationships[unit.name] > 30 and self.gender ~= unit.gender then
							self.house = unit.house
						end
					else
						self.relationships[unit.name] = (self.charisma() * math.random(-1,3) / 3 )
					end
				end
			end
		end
		for k,unit in ipairs(self.tile.occupants) do
			if unit.class == "UNIT" and unit ~= self then
				if self.relationships[unit.name] then
					self.relationships[unit.name] = self.relationships[unit.name] + self.charisma() * math.random(-1,3)
					unit.charismamodifier = unit.charismamodifier + (math.random(0,5) / 10)
				else
					self.relationships[unit.name] = self.charisma() * math.random(-1,3)
					unit.charismamodifier = unit.charismamodifier + (math.random(0,2) / 10)
				end
				if self.team ~= unit.team and self.relationships[unit.name] < self.agressiveness() * 10 then
					self:attack(unit)
				elseif self.relationships[unit.name] < self.agressiveness() * 10 - 50 then
					self:attack(unit)
				end
			end
		end
		--jobs
		--[[if self.joblife < self.lifetime - 10 then
			self.job = 0
		end]]--
		if self.job == 1 then
			--cutting wood
			if not self.jobstage then
				self.target = xGetNearest("RESOURCE_TREE", worldTable, self) --fuck basing it on sight then -_-
				if self.target then
					pathTo(self.tile, self.target.tile, worldTable, self.toMove, self)
					self.jobstage = 1
				else
					self.job = 5 --there are no trees we know about, look for some
				end
			elseif self.jobstage == 1 then
				if #self.toMove == 0 and self.target and self.tile == self.target.tile then
					--delayunit(self, 1)
					self.wood = self.wood + self.target.woodpersize --should be inventory when items are implemented.
					self.target.size = self.target.size - 1
					self.jobstage = 2
					pathTo(self.tile, teamTable[self.team].buildings[1].tile, worldTable, self.toMove, self)
				elseif #self.toMove == 0 then
					self.jobstage = 2 --something went wrong
				end
			elseif self.jobstage == 2 then
				if #self.toMove == 0 then
					teamTable[self.team].wood = teamTable[self.team].wood + self.wood
					self.wood = 0
					self.jobstage = nil
					self.job = 0
				else self.job = 0; self.jobstage = nil;
				end
			end
		elseif self.job == 2 then
			--make house
			if teamTable[self.team].wood < 10 then--10 wood for a house
				self.job = 1 --YOU DONT HAVE ENOUGH WOOD GO GET SOME
			else
				if not self.jobstage then 
					self.jobstage = 1
					for k,v in ipairs(teamTable[self.team].buildings) do
						if math.random(2) == 1 then
							for k2,v2 in ipairs(v.tile.neighbours) do
								if #v2.occupants == 0 then
									self.target = v2
									pathTo(self.tile, v2, worldTable, self.toMove, self)
									break
								end
							end
							break
						end
					end
				elseif self.jobstage == 1 then
					if #self.toMove == 0 and self.tile == self.target and self.tile.space >= 12 and teamTable[self.team].wood > 10 then
						teamTable[self.team].wood = teamTable[self.team].wood - 10
						self.house = createBuilding("HOUSE", "ECONOMIC", 10, self.team, self.tile)
						self.jobstage = nil
						self.job = 0
						delayunit(self, 5)
					elseif #self.toMove == 0 then
						self.job = 0 --something went wrong, get a new job
					end
				end
			end
		elseif self.job == 3 then
			--building farm
			if teamTable[self.team].wood < 15 then--15 wood for a farm
				self.job = 1 --AS ABOVE
			else
				if not self.jobstage then 
					self.jobstage = 1
					for k,v in ipairs(teamTable[self.team].buildings) do
						if math.random(2) == 1 and (v.name == "HOUSE" or v.name == "HUB") then
							for k2,v2 in ipairs(v.tile.neighbours) do
								if v2.space >= 12 then
									self.target = v2
									pathTo(self.tile, v2, worldTable, self.toMove, self)
									break
								end
							end
							break
						end
					end
				elseif self.jobstage == 1 then
					if #self.toMove == 0 and self.tile == self.target and self.tile.space >= 12 and teamTable[self.team].wood > 15 then
						delayunit(self, 5) -- 5 hours to build
						teamTable[self.team].wood = teamTable[self.team].wood - 15
						createBuilding("FARM", "ECONOMIC", 6, self.team, self.tile) --get ownership working soon >_<
						self.jobstage = nil
						self.job = 0
					elseif #self.toMove == 0 then
						self.jobstage = false --something went wrong
						self.job = 0
					end
				end
			end
		elseif self.job == 4 then
			--using farm
			if not self.jobstage then 
				self.jobstage = true
				self.joblife = self.lifetime
				for k,v in ipairs(teamTable[self.team].buildings) do
					if math.random(2) == 1 then
						if v.name == "FARM" then
							self.target = v
							pathTo(self.tile, v.tile, worldTable, self.toMove, self)
							break
						end
					end
				end
				if not self.target then
					self.job = 3 --make a farm, we have none
					self.jobstage = false
				end
			elseif #self.toMove == 0 then
				self.job = 0
				self.jobstage = false
				if self.tile == self.target.tile then
					if teamTable[self.team].wood > 2 then
						self.target:interact(self)
					end
				end
			end
		elseif self.job == 5 then
			--wander aimlessly/explore
			if not self.jobstage then
				pathTo(self.tile, self.seentiles[math.random(#self.seentiles)], self.seentiles, self.toMove, self)
				if math.random(5) == 1 then --map exploration
					pathTo(self.tile, worldTable[math.random(#worldTable)], worldTable, self.toMove, self)
				end
				self.jobstage = 1
			elseif #self.toMove == 0 and self.jobstage == 1 then
				self.job = 0
				self.jobstage = false
			end
		elseif self.job == 6 then
			--stand around, rest and talk
			if self.hp < self.maxhp / 2 and teamTable[self.team].food > 2 then
				self.hp = self.hp + math.random(1,10)
				teamTable[self.team].food = teamTable[self.team].food - 2
			end
			self.job = 0
		elseif self.job == 7 then
			--go to a house and rest in it
			if not self.jobstage then 
				self.jobstage = 1
				if not (type(self.house) == "table") then
					for k,v in ipairs(teamTable[self.team].buildings) do
						if math.random(2) == 1 then
							if v.name == "HOUSE" then
								self.target = v
								pathTo(self.tile, v.tile, worldTable, self.toMove, self)
								self.joblife = self.lifetime
								break
							end
						end
					end
				else
					pathTo(self.tile, self.house.tile, worldTable, self.toMove, self)
					self.target = self.house
				end
				if not self.target then
					self.job = 0
					self.jobstage = false
				end
			elseif self.jobstage == 1 or self.joblife < self.lifetime - 20 then
				if self.tile == self.target.tile and self.target.name == "HOUSE" then
					self.target:interact(self)
				end
				self.job = 0
				self.jobstage = false
			end
		elseif self.job == 8 then
			--seek out contact
			if not self.jobstage then
				self.class = "NOTUNIT"
				self.target = xGetNearest("UNIT", worldTable, self) --workaround for xget.
				self.class = "UNIT"
				if self.target then
					pathTo(self.tile, self.target.tile, worldTable, self.toMove, self)
					self.jobstage = 1
				else self.job = 0 end
			elseif #self.toMove == 0 then
				for k,v in ipairs(self.tile.occupants) do
					if v.class == "BUILDING" then
						v:interact(self) break
					end
				end
				self.job = 0
				self.jobstage = false
			end
		elseif self.job == 9 then
			--forage
			if not self.jobstage then
				self.target = xGetNearest("RESOURCE_TREE", worldTable, self) --will use grass once that's in.
				if self.target then
					pathTo(self.tile, self.target.tile, worldTable, self.toMove, self)
					self.jobstage = 1
				else self.job = 0 end
			elseif #self.toMove == 0 then
				teamTable[self.team].food = teamTable[self.team].food + math.random(3,8)
				self.job = 0
				self.jobstage = false
			end
		elseif self.job == 10 then
			--look for free buildings
			if not self.jobstage then
				for k,v in ipairs(worldTable.buildings) do
					if v.team == 0 then
						self.target = v
						pathTo(self.tile, self.target.tile, worldTable, self.toMove, self)
						self.jobstage = 1
						break
					end
				end
				if not self.target then
					self.job = 0
				end
			elseif #self.toMove == 0 then
				self.job = 0 --building update should take care of the rest
				self.jobstage = false
			end
		if self.job == 11 then --patrol our buildings
			if not self.jobstage then
				self.jobstage = 1
				pathTo(self.tile, teamTable[self.team].buildings[math.random(#teamTable[self.team].buildings)].tile, worldTable, self.toMove, self)
				if not self.target then
					self.job = 0
				end
			elseif #self.toMove == 0 then
				self.job = 0 --building update should take care of the rest
				self.jobstage = false
			end
		end
		else --JOB DECISION
			local team = teamTable[self.team]
			--[[if self.hp < self.maxhp / 4 then --if wounded or tired
				if team:getNumBuilding("HOUSE") >= 1 and team.food >= 1 then
					self.job = 7 --rest in house
				elseif team.food > 2 then
					self.job = 6 --rest where you are
				else
					if math.random(2) == 1 then --make food
						if team:getNumBuilding("FARM") > 0 then self.job = 4
						else self.job = 9 end --forage if we have no farms
					else
						self.job = 2 --make a house
					end
				end
			elseif self.lifetime > self.life * 3/4 then --you're old!
				if math.random(2) == 1 and team.tasks[1] then
					self.job = team.tasks[1]
					table.remove(team.tasks, 1)
				elseif math.random(2) == 1 then
					self.job = math.random(7,8)
				else
					if team:getNumBuilding("HOUSE") >= 1 and team.food >= 1 then
						self.job = 7 --rest in house
					elseif team.food > 2 then
						self.job = 6 --rest where you are
					else
						if math.random(2) == 1 then
							if team:getNumBuilding("FARM") > 0 then self.job = 4
							else self.job = 9 end --forage if we have no farms
						else
							self.job = 2 --make a house
						end
					end
				end
			elseif]]--
			if team.tasks[1] then
				self.job = team.tasks[1]
				table.remove(team.tasks, 1)
			else
				self.job = math.random(11)
			end
			self.jobstage = false
			self.target = nil
			self.joblife = math.floor(self.lifetime)
		end
			--end-----------------------------------------------------------------------------------------------needed for job age limiting, but will be on "child" factor
		--movement
		for i = 1, self.speed do
			if type(self.toMove) == "table" and #self.toMove > 0 then
				--move along a tile, and then remove it and update the speed timer.
				if self.toMove[1]:insertOccupant(self) then
				table.remove(self.toMove, 1)
				else break end --blocked
			else
				break
			end
		end
		self.hp = self.hp - 1 --doubles as stamina and starving
		if teamTable[self.team].food > 0 then
			teamTable[self.team].food = teamTable[self.team].food - math.random(0,1)
		else
			self.hp = self.hp - 2
		end
		--scale off the modifiers, so if they arent practiced, they die.
		self.agressivenessmodifier = self.agressivenessmodifier * 0.99
		self.intelligencemodifier = self.intelligencemodifier * 0.99
		self.lazinessmodifier = self.lazinessmodifier * 0.99
		self.charismamodifier = self.charismamodifier * 0.99
		self.strengthmodifier = self.strengthmodifier * 0.99
		--update the seen tiles
		self.seentiles = {}; table.insert(self.seentiles, self.tile); tabRadius(self.tile, worldTable, self.range, self.seentiles)
	end
end

function xGetNearest(class, st, unit) --update to be an operation soon plz
	local dist = 100 --arbitary limit of 100 tile radius
	local current = false
	for k,v in ipairs(st) do
		local adist = round(math.sqrt( math.abs(unit.tile.pos[1] - v.pos[1]) ^ 2 + math.abs(unit.tile.pos[2] - v.pos[2]) ^ 2 ))
		if adist < dist then
			for k,v in ipairs(v.occupants) do
				if class == v.class then
					dist = adist
					current = v
				end
			end
		end
	end
	return current
end

function pathTo(t1, t2, wt, st, unit)
	if t1 and t2 then
		for k,v in ipairs(wt) do
			v.adist = math.sqrt( math.abs(t2.pos[1] - v.pos[1]) ^ 2 + math.abs(t2.pos[2] - v.pos[2]) ^ 2 )
		end
	else
		return {}
	end
	local active = t1
	local maxdist = math.sqrt( math.abs(t2.pos[1] - active.pos[1]) ^ 2 + math.abs(t2.pos[2] - active.pos[2]) ^ 2 ) * 2
	if not active.adist then
		active.adist = maxdist / 2 end
	local count = 1
	while active ~= t2 do
		for k,v in ipairs(active.neighbours) do
			if v.adist then
				if v.adist < active.adist and unit:canFit(v) or v == t2 then
					active = v
				end
			end
		end
		if active == st[#st] and #st > 1 then --we didnt move!
			active.adist = 1000 --we dont want to go there again, treat it like its very far from the goal
			table.remove(st) --remove the most recent tile
			active = st[#st] --move back a step and try again
		else
			table.insert(st, active)
		end
		count = count + 1
		if count > maxdist then
			break --limit the search, we dont have all day.
		end
	end
	-- create a list P
 -- add the start node S, to P giving it one element
 -- Until first path of P ends with G, or P is empty
        -- extract the first path from P
        -- extend first path one step to all neighbors creating X new paths
        -- reject all paths with loops
                -- for all paths that end at the same node, keep only the shortest one.
        -- add each remaining new path to of P
        -- Sort all paths by total underestimate, shortest first.
 -- If G found -> success. Else -> failure.
end

function delayunit(self, turns)
	if turns <= 50 and turns ~= math.huge then
		self.delay = self.lifetime + turns
	end
end
