--trees growth functions --
--so the wood supply doesnt run out
--currently pretty basic, i'll update it with more types of growth soon, and split it into categories, not just 2 types.

--[[TODO:
	--make many different types of growth (sapling, shrubbery cover, whatever)
	--create more tree sprites <_<
]]--

function woodGrowth(self)
	for k,v in ipairs(self.tile.neighbours) do
		for k2,v2 in ipairs(v.occupants) do
			if v2.class == "RESOURCE_TREE" and math.random(2) == 2 then
				self.mate = v2
				break
			end
		end
	end
	if self.size <= getlps(self) - 1 and counttreeneighbours(self) > 2 then
		self.size = self.size + 1
	elseif round(self.size) == getlps(self) - 1 and math.random(self.lifetime + 2) < 5 then
		self.size = getlps(self)
		for k,v in ipairs(self.tile.neighbours) do
			if #v.occupants == 0 and v.type == (3 or 4 or 5 or 6) then
				tAvgNeighbours(v)
				if not self.mate then
					createTreeReproduction(self, self, v)
				else
					createTreeReproduction(self, self.mate, v)
				end
			end
		end
	elseif self.size == getlps(self) and self.lifetime > 5 then
		if self.tile.tag ~= "FOREST" then
			self.tile.tag = "FOREST"
			self.tile.type = 4
			tAvgNeighbours(self.tile)
		end
		for k,v in ipairs(self.tile.neighbours) do
			if #v.occupants == 0 and (v.tag == "PLAINS" or v.tag == "FOREST" or v.tag == "NORMAL" or v.type == (3 or 4 or 5 or 6))
			and math.random(self.lifetime / 10) == 1 then
				tAvgNeighbours(v)
				if not self.mate then
					createTreeReproduction(self, self, v)
				else
					createTreeReproduction(self, self.mate, v)
				end
			elseif #v.occupants > 0 and v.tag == "NORMAL" and v.type == (3 or 4 or 5 or 6) then
				v.type = 4
				tAvgNeighbours(v)
			end
		end
	end
end

function scrubGrowth(self)
	for k,v in ipairs(self.tile.neighbours) do
		for k2,v2 in ipairs(v.occupants) do
			if v2.class == "RESOURCE_TREE" and math.random(2) == 2 then
				self.mate = v2
				break
			end
		end
	end
	if round(self.lifetime + math.random() - math.random(), 1) == round(self.lifetime) and self.lifetime > 2 then
		if round(self.size) < getlps(self) and math.random(0,round(self.lifetime / 2)) == 1 then
			self.size = self.size + (math.random(-5,10)/10)
		elseif self.size == getlps(self) and self.lifetime > 5 then
			if self.lifetime > math.random(30,60) and counttreeneighbours(self) < 3 then --growth spurts based on clumping
				self.size = self.size - math.random(0,1)
				for k,v in ipairs(self.tile.neighbours) do
					if #v.occupants == 0 and v.tag == "PLAINS" then
						tAvgNeighbours(v)
						if not self.mate then
							createTreeReproduction(self, self, v)
						else
							createTreeReproduction(self, self.mate, v)
						end
					end
				end
			end
			for k,v in ipairs(self.tile.neighbours) do
				if #v.occupants == 0 and (v.tag == "PLAINS" or v.tag == "FOREST" or v.tag == "NORMAL" or v.type == (3 or 4 or 5 or 6))
				and math.random(self.lifetime / 5) == 1 then
					tAvgNeighbours(v)
					if not self.mate then
						createTreeReproduction(self, self, v)
					else
						createTreeReproduction(self, self.mate, v)
					end
				end
			end
		end
	end
end

function counttreeneighbours(self) --counting how many neighbours have trees.
	local count = 0 --can be reversed if you subtract from #tree.tile.neighbours
	for k,v in ipairs(self.tile.neighbours) do
		for k2,v2 in ipairs(v.occupants) do
			if v2.class == "RESOURCE_TREE" then
				count = count + 1
			end
		end
	end
	return count
end

function getlps(tree) --largest possible size
	if vegetationmat[tree.tile.type][tree.sprite] then
		return #vegetationmat[tree.tile.type][tree.sprite]
	else
		tree:destroy()
		return 0
	end
end