TASKS_ECO = {
	["GET WOOD"] = getWood()
	["MAKE FOOD"] = makeFood()
	["CREATE HOUSING"] = build("HOUSE")
	["CREATE FARM"] = build("FARM")
}
	
TASKS = {
	["ECO"] = TASKS_ECO
}

--create the job class
job = {
	maxunits = 3
	currentunits = 0
	task = idle()
	name = "BASE JOB"
}
job.__index = job --set the job class as its own index for inheritance

function job:new(existing, maxunits, currentunits, task, name)
	o = existing or {} -- create a new table if the user doesnt provide one
	setmetatable(o, self) --set the metatable
	o.maxunits = maxunits
	o.currentunits = currentunits
	o.task = task
	o.name = name
	return o
end